<!DOCTYPE html>
<html lang='en'>
  <head>
    <meta charset='utf-8'>
      <link rel='stylesheet' href='/style.css'>
      <link rel='icon' type='image/png' sizes='32x32' href='images/favicon-32x32.png'>
      <title>Nils - Markov</title>
  </head>
  <body>

    <div id='navbar'>
      <a href='/index.html'><img src="images/favicon-32x32.png" alt="Home"></a>
      <a href='/laser.html'>Laser</a>
      <a href='/bounce.html'>Bounce</a>
      <a href='/functional-bounce.html'>FBounce</a>
      <a href='/collision.html'>Collision</a>
      <a href='/magnetic-field.html'>Magnetic-Field</a>
      <a class='active' href='/markov.html'>Markov Chains</a>
      <a href='/mandelbrot.html'>Mandelbrot</a>
      <div class='socials'>
        <a href='https://gitlab.com/_sonsan' target='_blank'><img src='images/GitHub-Mark-Light-32x32.png'></a>
      </div>
    </div>

    <canvas id='canvas' width='500' height='500'></canvas>

    <script>
      /* sources:
        /_ http://www.thi.cs.uni-frankfurt.de/lehre/dismod/ws1819/dismod_ws1819_skript.pdf
        /_ http://www.thi.cs.uni-frankfurt.de/lehre/dismod/ws1819/dismod_ws1819_skript.pdf
        /_ https://www.w3schools.com/js/js_arrow_function.asp
      */

      class Matrix {
        // provides utility
        constructor(row_vectors) {
          this.M = row_vectors;
          this.n = this.M[0].length;
          this.E = this.get_identity_matrix();
        }

        transpose() {
          // returns the current matrix in transposed form.
          let T = [];
          for (var j=0; j<this.n; j++) {
            let tmp = [];
            for (var i=0; i<this.n; i++) {
              tmp.push(this.M[i][j]);
            }
            T.push(tmp);
          }
          return T;
        }

        get_identity_matrix() {
          // returns E with the property: M*E = M
          let E = []
          for (var i=0; i<this.n; i++) {
            let tmp = [];
            for (var j=0; j<this.n; j++) {
              if (i !== j) {
                tmp.push(0);
              } else {
                tmp.push(1);
              }
            }
            E.push(tmp);
          }
          return E;
        }

        MM_product(B) {
          // calculates & returns A = M*B with M,B in R^nxn
          let A = [];
          for (const M_row of this.M) {
            let tmp = []
            for (const B_row of B.transpose()) {
              let p = 0;
              for (var i=0; i<this.n; i++) {
                p += M_row[i]*B_row[i];
              }
              tmp.push(p);
            }
            A.push(tmp);
          }
          return A;
        }


        MV_product(V) {
          // calculates M*V with M in R^nxn and V in R^n
        }
      }


      class MarkovChain {
        constructor() {
          // will generate the nodes and connections via the transition matrix.
        }

        calculate_page_ranks(){
          // returns a array which contains the node's page-ranks
        }

        generate_transition_matrix(){
          // NOTE transition matrix will be given by the user.
        }

      }

      let A = new Matrix([[1,2,3],[2,1,3],[4,2,1]]);
      let B = new Matrix([[1,1,1],[2,2,2],[3,3,3]]);
      let p = A.MM_product(B);
      console.log(p);
    </script>

  </body>
</html>
